#---------------------------------------------------------------------------
#
#   SuPy GUI - Button base - Cocoa
#
#---------------------------------------------------------------------------

from traceback import print_exc
from weakref import proxy
from Foundation import NSObject
from AppKit import NSButton
from g_button_base import GButtonBase

class ButtonBase(GButtonBase):

	def __init__(self, **kwds):
		GButtonBase.__init__(self, **kwds)
		ns = self._ns_view
		ns.py = proxy(self)
		ns.setAction_('doAction:')
		ns.setTarget_(ns_action_target)

	def get_title(self):
		return self._ns_view.title()
	
	def set_title(self, x):
		self._ns_view.setTitle_(x)

#---------------------------------------------------------------------------

class PyNSButton(NSButton):
	pass

#---------------------------------------------------------------------------

class PyNSActionTarget(NSObject):

	def doAction_(self, sender):
		try:
			sender.py.do_action()
		except:
			print_exc()

ns_action_target = PyNSActionTarget.alloc().init()
